
package net.mcreator.cavernousechoes.entity;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.network.PlayMessages;
import net.minecraftforge.network.NetworkHooks;
import net.minecraftforge.common.ForgeMod;

import net.minecraft.world.level.pathfinder.BlockPathTypes;
import net.minecraft.world.level.levelgen.Heightmap;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.LevelReader;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.crafting.Ingredient;
import net.minecraft.world.entity.projectile.ThrownPotion;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.entity.monster.Monster;
import net.minecraft.world.entity.ai.navigation.WaterBoundPathNavigation;
import net.minecraft.world.entity.ai.navigation.PathNavigation;
import net.minecraft.world.entity.ai.goal.target.NearestAttackableTargetGoal;
import net.minecraft.world.entity.ai.goal.target.HurtByTargetGoal;
import net.minecraft.world.entity.ai.goal.TryFindWaterGoal;
import net.minecraft.world.entity.ai.goal.TemptGoal;
import net.minecraft.world.entity.ai.goal.RestrictSunGoal;
import net.minecraft.world.entity.ai.goal.RemoveBlockGoal;
import net.minecraft.world.entity.ai.goal.RandomStrollGoal;
import net.minecraft.world.entity.ai.goal.RandomLookAroundGoal;
import net.minecraft.world.entity.ai.goal.MoveBackToVillageGoal;
import net.minecraft.world.entity.ai.goal.MeleeAttackGoal;
import net.minecraft.world.entity.ai.goal.AvoidEntityGoal;
import net.minecraft.world.entity.ai.control.MoveControl;
import net.minecraft.world.entity.ai.attributes.Attributes;
import net.minecraft.world.entity.ai.attributes.AttributeSupplier;
import net.minecraft.world.entity.SpawnPlacements;
import net.minecraft.world.entity.Pose;
import net.minecraft.world.entity.MobType;
import net.minecraft.world.entity.Mob;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.world.entity.EntityDimensions;
import net.minecraft.world.entity.Entity;
import net.minecraft.world.entity.AreaEffectCloud;
import net.minecraft.world.damagesource.DamageTypes;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.Difficulty;
import net.minecraft.util.Mth;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.protocol.game.ClientGamePacketListener;
import net.minecraft.network.protocol.Packet;
import net.minecraft.core.BlockPos;

import net.mcreator.cavernousechoes.procedures.DepthlingScoutEntityDiesProcedure;
import net.mcreator.cavernousechoes.init.CavernousEchoesModItems;
import net.mcreator.cavernousechoes.init.CavernousEchoesModEntities;
import net.mcreator.cavernousechoes.init.CavernousEchoesModBlocks;

public class DepthlingScoutEntity extends Monster {
	public DepthlingScoutEntity(PlayMessages.SpawnEntity packet, Level world) {
		this(CavernousEchoesModEntities.DEPTHLING_SCOUT.get(), world);
	}

	public DepthlingScoutEntity(EntityType<DepthlingScoutEntity> type, Level world) {
		super(type, world);
		setMaxUpStep(0.6f);
		xpReward = 0;
		setNoAi(false);
		this.setPathfindingMalus(BlockPathTypes.WATER, 0);
		this.moveControl = new MoveControl(this) {
			@Override
			public void tick() {
				if (DepthlingScoutEntity.this.isInWater())
					DepthlingScoutEntity.this.setDeltaMovement(DepthlingScoutEntity.this.getDeltaMovement().add(0, 0.005, 0));
				if (this.operation == MoveControl.Operation.MOVE_TO && !DepthlingScoutEntity.this.getNavigation().isDone()) {
					double dx = this.wantedX - DepthlingScoutEntity.this.getX();
					double dy = this.wantedY - DepthlingScoutEntity.this.getY();
					double dz = this.wantedZ - DepthlingScoutEntity.this.getZ();
					float f = (float) (Mth.atan2(dz, dx) * (double) (180 / Math.PI)) - 90;
					float f1 = (float) (this.speedModifier * DepthlingScoutEntity.this.getAttribute(Attributes.MOVEMENT_SPEED).getValue());
					DepthlingScoutEntity.this.setYRot(this.rotlerp(DepthlingScoutEntity.this.getYRot(), f, 10));
					DepthlingScoutEntity.this.yBodyRot = DepthlingScoutEntity.this.getYRot();
					DepthlingScoutEntity.this.yHeadRot = DepthlingScoutEntity.this.getYRot();
					if (DepthlingScoutEntity.this.isInWater()) {
						DepthlingScoutEntity.this.setSpeed((float) DepthlingScoutEntity.this.getAttribute(Attributes.MOVEMENT_SPEED).getValue());
						float f2 = -(float) (Mth.atan2(dy, (float) Math.sqrt(dx * dx + dz * dz)) * (180 / Math.PI));
						f2 = Mth.clamp(Mth.wrapDegrees(f2), -85, 85);
						DepthlingScoutEntity.this.setXRot(this.rotlerp(DepthlingScoutEntity.this.getXRot(), f2, 5));
						float f3 = Mth.cos(DepthlingScoutEntity.this.getXRot() * (float) (Math.PI / 180.0));
						DepthlingScoutEntity.this.setZza(f3 * f1);
						DepthlingScoutEntity.this.setYya((float) (f1 * dy));
					} else {
						DepthlingScoutEntity.this.setSpeed(f1 * 0.05F);
					}
				} else {
					DepthlingScoutEntity.this.setSpeed(0);
					DepthlingScoutEntity.this.setYya(0);
					DepthlingScoutEntity.this.setZza(0);
				}
			}
		};
		refreshDimensions();
	}

	@Override
	public Packet<ClientGamePacketListener> getAddEntityPacket() {
		return NetworkHooks.getEntitySpawningPacket(this);
	}

	@Override
	protected PathNavigation createNavigation(Level world) {
		return new WaterBoundPathNavigation(this, world);
	}

	@Override
	protected void registerGoals() {
		super.registerGoals();
		this.goalSelector.addGoal(1, new MeleeAttackGoal(this, 1.5, true) {
			@Override
			protected double getAttackReachSqr(LivingEntity entity) {
				return this.mob.getBbWidth() * this.mob.getBbWidth() + entity.getBbWidth();
			}
		});
		this.goalSelector.addGoal(2, new RandomStrollGoal(this, 0.9));
		this.targetSelector.addGoal(3, new HurtByTargetGoal(this).setAlertOthers());
		this.goalSelector.addGoal(4, new RandomLookAroundGoal(this));
		this.goalSelector.addGoal(5, new TryFindWaterGoal(this));
		this.goalSelector.addGoal(6, new TemptGoal(this, 1.1, Ingredient.of(CavernousEchoesModItems.DEPTHLING_FEED.get()), false));
		this.goalSelector.addGoal(7, new RemoveBlockGoal(CavernousEchoesModBlocks.BLOOK_BODY.get(), this, 1, (int) 3));
		this.goalSelector.addGoal(8, new RemoveBlockGoal(CavernousEchoesModBlocks.BLOOK.get(), this, 1, (int) 3));
		this.goalSelector.addGoal(9, new RemoveBlockGoal(CavernousEchoesModBlocks.BLOOK_END.get(), this, 1, (int) 3));
		this.goalSelector.addGoal(10, new RemoveBlockGoal(CavernousEchoesModBlocks.BLOOK_RESERVE.get(), this, 1, (int) 3));
		this.goalSelector.addGoal(11, new RemoveBlockGoal(CavernousEchoesModBlocks.BLOOK_KNOB.get(), this, 1, (int) 3));
		this.goalSelector.addGoal(12, new RemoveBlockGoal(CavernousEchoesModBlocks.BLOOK_KNOB_CRAFTABLE.get(), this, 1, (int) 3));
		this.goalSelector.addGoal(13, new MoveBackToVillageGoal(this, 0.6, false));
		this.goalSelector.addGoal(14, new RestrictSunGoal(this));
		this.goalSelector.addGoal(16, new AvoidEntityGoal<>(this, InfecterEntity.class, (float) 6, -1, -1.2));
		this.targetSelector.addGoal(17, new NearestAttackableTargetGoal(this, Player.class, true, true));
		this.goalSelector.addGoal(18, new RemoveBlockGoal(CavernousEchoesModBlocks.BROODLING_LURE.get(), this, 1.5, (int) 7));
		this.goalSelector.addGoal(19, new RemoveBlockGoal(CavernousEchoesModBlocks.BROODLING_CONDUIT.get(), this, 0.1, (int) 128));
	}

	@Override
	public MobType getMobType() {
		return MobType.ARTHROPOD;
	}

	@Override
	public double getMyRidingOffset() {
		return 0.1D;
	}

	@Override
	public double getPassengersRidingOffset() {
		return super.getPassengersRidingOffset() + 0.1;
	}

	@Override
	public SoundEvent getAmbientSound() {
		return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("cavernous_echoes:depthling.ambient"));
	}

	@Override
	public void playStepSound(BlockPos pos, BlockState blockIn) {
		this.playSound(ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("block.grass.step")), 0.15f, 1);
	}

	@Override
	public SoundEvent getHurtSound(DamageSource ds) {
		return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("cavernous_echoes:depthling.gets.hurt"));
	}

	@Override
	public SoundEvent getDeathSound() {
		return ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("cavernous_echoes:depthling.death"));
	}

	@Override
	public boolean hurt(DamageSource damagesource, float amount) {
		if (damagesource.getDirectEntity() instanceof AbstractArrow)
			return false;
		if (damagesource.getDirectEntity() instanceof ThrownPotion || damagesource.getDirectEntity() instanceof AreaEffectCloud)
			return false;
		if (damagesource.is(DamageTypes.CACTUS))
			return false;
		if (damagesource.is(DamageTypes.DROWN))
			return false;
		if (damagesource.is(DamageTypes.EXPLOSION))
			return false;
		if (damagesource.is(DamageTypes.TRIDENT))
			return false;
		if (damagesource.is(DamageTypes.DRAGON_BREATH))
			return false;
		return super.hurt(damagesource, amount);
	}

	@Override
	public void die(DamageSource source) {
		super.die(source);
		DepthlingScoutEntityDiesProcedure.execute(this.level(), this.getX(), this.getY(), this.getZ());
	}

	@Override
	public boolean checkSpawnObstruction(LevelReader world) {
		return world.isUnobstructed(this);
	}

	@Override
	public boolean canBreatheUnderwater() {
		double x = this.getX();
		double y = this.getY();
		double z = this.getZ();
		Level world = this.level();
		Entity entity = this;
		return true;
	}

	@Override
	public boolean isPushedByFluid() {
		double x = this.getX();
		double y = this.getY();
		double z = this.getZ();
		Level world = this.level();
		Entity entity = this;
		return false;
	}

	@Override
	public boolean isPushable() {
		return false;
	}

	@Override
	protected void doPush(Entity entityIn) {
	}

	@Override
	protected void pushEntities() {
	}

	@Override
	public EntityDimensions getDimensions(Pose pose) {
		return super.getDimensions(pose).scale(0.8f);
	}

	public static void init() {
		SpawnPlacements.register(CavernousEchoesModEntities.DEPTHLING_SCOUT.get(), SpawnPlacements.Type.ON_GROUND, Heightmap.Types.MOTION_BLOCKING_NO_LEAVES,
				(entityType, world, reason, pos, random) -> (world.getDifficulty() != Difficulty.PEACEFUL && Monster.isDarkEnoughToSpawn(world, pos, random) && Mob.checkMobSpawnRules(entityType, world, reason, pos, random)));
	}

	public static AttributeSupplier.Builder createAttributes() {
		AttributeSupplier.Builder builder = Mob.createMobAttributes();
		builder = builder.add(Attributes.MOVEMENT_SPEED, 0.3);
		builder = builder.add(Attributes.MAX_HEALTH, 4);
		builder = builder.add(Attributes.ARMOR, 4.5);
		builder = builder.add(Attributes.ATTACK_DAMAGE, 0);
		builder = builder.add(Attributes.FOLLOW_RANGE, 16);
		builder = builder.add(Attributes.KNOCKBACK_RESISTANCE, 0.05);
		builder = builder.add(Attributes.ATTACK_KNOCKBACK, 0.1);
		builder = builder.add(ForgeMod.SWIM_SPEED.get(), 0.3);
		return builder;
	}
}
