
package net.mcreator.cavernousechoes.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.core.particles.ParticleTypes;
import net.minecraft.core.particles.ParticleOptions;

import net.mcreator.cavernousechoes.init.CavernousEchoesModItems;
import net.mcreator.cavernousechoes.init.CavernousEchoesModFluids;
import net.mcreator.cavernousechoes.init.CavernousEchoesModFluidTypes;
import net.mcreator.cavernousechoes.init.CavernousEchoesModBlocks;

public abstract class AlgaeWaterFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> CavernousEchoesModFluidTypes.ALGAE_WATER_TYPE.get(), () -> CavernousEchoesModFluids.ALGAE_WATER.get(),
			() -> CavernousEchoesModFluids.FLOWING_ALGAE_WATER.get()).explosionResistance(100f).slopeFindDistance(5).bucket(() -> CavernousEchoesModItems.ALGAE_WATER_BUCKET.get()).block(() -> (LiquidBlock) CavernousEchoesModBlocks.ALGAE_WATER.get());

	private AlgaeWaterFluid() {
		super(PROPERTIES);
	}

	@Override
	public ParticleOptions getDripParticle() {
		return ParticleTypes.ITEM_SLIME;
	}

	public static class Source extends AlgaeWaterFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends AlgaeWaterFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
