
package net.mcreator.cavernousechoes.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;
import net.minecraft.core.particles.SimpleParticleType;
import net.minecraft.core.particles.ParticleOptions;

import net.mcreator.cavernousechoes.init.CavernousEchoesModParticleTypes;
import net.mcreator.cavernousechoes.init.CavernousEchoesModItems;
import net.mcreator.cavernousechoes.init.CavernousEchoesModFluids;
import net.mcreator.cavernousechoes.init.CavernousEchoesModFluidTypes;
import net.mcreator.cavernousechoes.init.CavernousEchoesModBlocks;

public abstract class CleansedWaterFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> CavernousEchoesModFluidTypes.CLEANSED_WATER_TYPE.get(), () -> CavernousEchoesModFluids.CLEANSED_WATER.get(),
			() -> CavernousEchoesModFluids.FLOWING_CLEANSED_WATER.get()).explosionResistance(100f).bucket(() -> CavernousEchoesModItems.CLEANSED_WATER_BUCKET.get()).block(() -> (LiquidBlock) CavernousEchoesModBlocks.CLEANSED_WATER.get());

	private CleansedWaterFluid() {
		super(PROPERTIES);
	}

	@Override
	public ParticleOptions getDripParticle() {
		return (SimpleParticleType) (CavernousEchoesModParticleTypes.CLEANSEDWATERPARTICLE.get());
	}

	public static class Source extends CleansedWaterFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends CleansedWaterFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
