
package net.mcreator.cavernousechoes.fluid;

import net.minecraftforge.fluids.ForgeFlowingFluid;

import net.minecraft.world.level.material.FluidState;
import net.minecraft.world.level.material.Fluid;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.LiquidBlock;

import net.mcreator.cavernousechoes.init.CavernousEchoesModItems;
import net.mcreator.cavernousechoes.init.CavernousEchoesModFluids;
import net.mcreator.cavernousechoes.init.CavernousEchoesModFluidTypes;
import net.mcreator.cavernousechoes.init.CavernousEchoesModBlocks;

public abstract class DarknessFluid extends ForgeFlowingFluid {
	public static final ForgeFlowingFluid.Properties PROPERTIES = new ForgeFlowingFluid.Properties(() -> CavernousEchoesModFluidTypes.DARKNESS_TYPE.get(), () -> CavernousEchoesModFluids.DARKNESS.get(),
			() -> CavernousEchoesModFluids.FLOWING_DARKNESS.get()).explosionResistance(100f).tickRate(20).slopeFindDistance(15).bucket(() -> CavernousEchoesModItems.DARKNESS_BUCKET.get())
			.block(() -> (LiquidBlock) CavernousEchoesModBlocks.DARKNESS.get());

	private DarknessFluid() {
		super(PROPERTIES);
	}

	public static class Source extends DarknessFluid {
		public int getAmount(FluidState state) {
			return 8;
		}

		public boolean isSource(FluidState state) {
			return true;
		}
	}

	public static class Flowing extends DarknessFluid {
		protected void createFluidStateDefinition(StateDefinition.Builder<Fluid, FluidState> builder) {
			super.createFluidStateDefinition(builder);
			builder.add(LEVEL);
		}

		public int getAmount(FluidState state) {
			return state.getValue(LEVEL);
		}

		public boolean isSource(FluidState state) {
			return false;
		}
	}
}
